use mylib;

use clap::{Arg, App};
use log::{/*info,*/ trace, warn};

#[derive(Debug)]
struct Settings {
    config: String,
}

fn parse_args() -> Result<Settings, Box<dyn std::error::Error>> {
    let matches = App::new("Given files in a directory, determine values and store results in a directory")
        .version("1.0")
        .author("Lukas Prokop <lukas.prokop@iaik.tugraz.at>")
        .arg(Arg::with_name("config")
            .short("c")
            .long("config")
            .value_name("FILE")
            .help("Sets a custom config file")
            .takes_value(true))
        .get_matches();

    let config: &str = matches.value_of("config").unwrap_or("libconf.conf");

    Ok(Settings { config: config.to_string() })
}

fn run(settings: &Settings) -> Result<(), Box<dyn std::error::Error>> {
    mylib::answer(3)?;

    warn!("I am about to finish");
    trace!(
        target: "exec2", "config = {}",
        settings.config
    );

    Ok(())
}

fn main() {
    let settings = match parse_args() {
        Ok(s) => s,
        Err(e) => { eprintln!("{}", e); std::process::exit(1) },
    };

    match run(&settings) {
        Ok(_) => {},
        Err(e) => { eprintln!("error: {}", e); std::process::exit(2) },
    };
}