// dependencies
use std::error;
use std::fmt;

// Argument error
#[derive(Debug)]
pub struct ArgError(String);

impl error::Error for ArgError {}

impl fmt::Display for ArgError {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "argument error: {}", self.0)
    }
}

impl ArgError {
    pub fn new(text: &str) -> Result<ArgError, Box<dyn error::Error>> {
        Ok(ArgError(text.to_string()))
    }

    pub fn new_err(text: &str) -> Box<ArgError> {
        Box::new(ArgError(text.to_string()))
    }
}
