use std::fmt;
use std::error;


//#[derive(Debug)]
pub struct MyType {
    data: u64,
}

impl fmt::Display for MyType {
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
        write!(f, "Type({})", self.data)
    }
}

impl fmt::Debug for MyType {
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
        f.debug_struct("MyType")
         .field("data", &self.data)
         .finish()
    }
}

impl MyType {
    pub fn new() -> Result<MyType, Box<dyn error::Error>> {
        Ok(MyType { data: 0 })
    }

    pub fn inc(&self) -> u64 {
        self.data + 1
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_value() -> Result<(), Box<dyn error::Error>> {
        assert_eq!(43, MyType::new()?.inc());
        Ok(())
    }
}